#!/usr/bin/perl -w


$usage = "makebasichex.perl program.prg\n";


$prg = shift || die $usage;
$txt = shift || die $usage;
shift && die $usage;


sub readhex($) {
  my $fh = shift;
  my $data;

  read($fh, $data, 1) || return;
  return(sprintf("%02x", ord($data)));
}

open(PRG, $prg) || die "Couldn't open $prg: $!\n";

if (readhex(PRG) ne "00") {
  die "Program must start on page boundary\n";
}
$la = readhex(PRG);
$line = 1;
$w = 0;
$sum = 0;

$out = "  0 goto 100\n";

while ($d = readhex(PRG)) {
  if ($w == 0) {
    $out .= sprintf("%3s data ", $line);
  }
  $out .= $d;
  $sum += hex($d);
  if (++$w == 15) {
    $out .= sprintf("%02x\n", $sum & 0xff);
    $sum = 0;
    ++$line;
    $w = 0;
  }
}
if ($w) {
  $out .= sprintf("%02x\n", $sum & 0xff);
}


$out .= <<END;
 89 data end
 90 h\$ = left\$(x\$, 1) : gosub 91 : x = h * 16 : h\$ = right\$(x\$, 1) : gosub 91 : x = x + h : return
 91 h = asc(h\$) - 48 : if h > 9 then h = h - 7
 92 return
100 l = 1 : x\$ = "$la" : gosub 90 : a = x * 256 : s = a
110 print "line";l : reada\$ : if a\$ = "end" then print "sys";s : end
111 x\$ = right\$(a\$, 2) : gosub 90 : ck = x : c = 0
120 for i = 1 to len(a\$) - 2 step 2 : x\$ = mid\$(a\$, i, 2) : gosub 90 : poke a, x : a = a + 1 : c = c + x : next
130 c = c and 255 : if c = ck then l = l + 1 : goto 110
140 print "checksum error"
END

close(PRG);

open(TXT, ">$txt") || die "Couldn't save to $txt: $!\n";
print TXT $out;
close(TXT);
